#include <File.au3>
#include <array.au3>

$txtdir = @ScriptDir & "\txt"
$pdfdir = @ScriptDir & "\pic"
$outdir = @ScriptDir & "\out"

Global $pdflist

$limit = Int ( InputBox ("Last file", "What is the last file number?", "") )
$start = 1

HotKeySet("{ESC}", "Terminate")

for $i=$start to $limit step 1
	If StringLen ($i) = 1 then $filename = "000" & $i
	If StringLen ($i) = 2 then $filename = "00" & $i
	If StringLen ($i) = 3 then $filename = "0" & $i
	$djcommands = "cjb2 -dpi 600 -lossy " & $filename & ".tif " & $filename & ".djvu"
	RunWait($djcommands, $txtdir, @SW_HIDE)
Next

for $i=$start to $limit step 1
	If StringLen ($i) = 1 then $filename = "000" & $i
	If StringLen ($i) = 2 then $filename = "00" & $i
	If StringLen ($i) = 3 then $filename = "0" & $i
	$ddjcommands = "ddjvu -format=tiff " & $filename & ".djvu " & $filename & ".tif"
	RunWait($ddjcommands, $txtdir, @SW_HIDE)
Next

for $i=$start to $limit step 1
	If StringLen ($i) = 1 then $filename = "000" & $i
	If StringLen ($i) = 2 then $filename = "00" & $i
	If StringLen ($i) = 3 then $filename = "0" & $i
	$magickcommands = "imagemagick -compress Group4 " & $filename & ".tif " & $filename & ".pdf"
	RunWait($magickcommands, $txtdir, @SW_HIDE)
Next

for $i=$start to $limit step 1
	If StringLen ($i) = 1 then $filename = "000" & $i
	If StringLen ($i) = 2 then $filename = "00" & $i
	If StringLen ($i) = 3 then $filename = "0" & $i
	$pdftkcommands = "pdftk " & "txt\" & $filename & ".pdf" & " stamp " & "pic\" & $filename & ".sep.pdf" & " output " & "out\" & $filename & ".pdf"
	If FileExists($pdfdir & "\" & $filename & ".sep.pdf") Then
		RunWait($pdftkcommands, @ScriptDir, @SW_HIDE)
	Else
		FileCopy($txtdir & "\" & $filename & ".pdf",$outdir & "\" & $filename & ".pdf")
	EndIf
	$pdflist = $pdflist & $filename & ".pdf "
Next

RunWait ("pdftk " & $pdflist & "output " & "out.pdf",$outdir, @SW_HIDE)

MsgBox(0,"All Done!","Finished processing files.")

Func Terminate ()
	Exit 0
EndFunc